SystemOrganization addCategory: #'TyH-TP-Final'!
SystemOrganization addCategory: #'TyH-TP-Final-Test'!
SystemOrganization addCategory: #'TyH-TP-Final-Modelo'!

Object subclass: #Emisor
	instanceVariableNames: 'nombre apellido DNI CUIT direccion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!Emisor class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 21:58'!
crear: unDNI nombre: unNombre apellido: unApellido cuit: unCUIT direccion: unaDireccion

| instancia |

instancia := Emisor new.

instancia setDNI: unDNI.
instancia setNombre: unNombre.
instancia setApellido: unApellido.
instancia setCUIT: unCUIT.
instancia setDireccion: unaDireccion.

^ instancia.


	! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:50'!
getApellido
	^apellido 

! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getCUIT
	^CUIT! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getDNI
	^DNI! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:51'!
getDireccion
	^direccion ! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:52'!
getNombre
	^nombre ! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:54'!
setApellido: unApellido

	apellido := unApellido.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:54'!
setCUIT: unCUIT

	CUIT := unCUIT.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setDNI: unDNI

	DNI :=DNI.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setDireccion: unaDireccion

	direccion := unaDireccion.! !

!Emisor methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 21:55'!
setNombre: unNombre

	nombre := unNombre.! !

Object subclass: #Order
	instanceVariableNames: 'cantidadUnidades fechaIngreso precio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

Order subclass: #OrdenCompra
	instanceVariableNames: 'direccionRecepcion formaEnvio'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrdenCompra class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 11:47'!
crear:unaFechaIngreso
cantidad:unaCantidadUnidades
precio:unPrecio
recibirEn:unaDireccionRecepcion
enviarComo: unaFormaEnvio

| instancia |

instancia := OrdenCompra new.

instancia setFechaIngreso: unaFechaIngreso.
instancia setCantidadUnidades: unaCantidadUnidades.
instancia setPrecio: unPrecio.
instancia setDireccionRecepcion: unaDireccionRecepcion.
instancia setFormaEnvio: unaFormaEnvio.

^instancia 
! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
getDireccionRecepcion
 ^direccionRecepcion ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
getFormaEnvio
 ^formaEnvio ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:30'!
setDireccionRecepcion: unaDireccionRecepcion
  direccionRecepcion  := unaDireccionRecepcion ! !

!OrdenCompra methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:29'!
setFormaEnvio: unaFormaEnvio
 ^formaEnvio := unaFormaEnvio ! !

Order subclass: #OrdenVenta
	instanceVariableNames: 'fechaDisponibilidad medioPago'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrdenVenta class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 11:50'!
crear:unaFechaIngreso
cantidad:unaCantidadUnidades
precio:unPrecio
disponibleEnFecha:unaFechaDisponibilidad
pagoEn: unMedioPago

| instancia |

instancia := OrdenVenta new.

instancia setFechaIngreso: unaFechaIngreso.
instancia setCantidadUnidades: unaCantidadUnidades.
instancia setPrecio: unPrecio.
instancia setFechaDisponibilidad: unaFechaDisponibilidad.
instancia setMedioPago: unMedioPago.

^instancia 
! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
getFechaDisponibilidad
 ^fechaDisponibilidad  ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
getMedioPago
 ^medioPago ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:31'!
setFechaDisponibilidad: unaFechaDisponibilidad
  fechaDisponibilidad   := unaFechaDisponibilidad ! !

!OrdenVenta methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:32'!
setMedioPago: unMedioPago
  medioPago := unMedioPago ! !

!Order class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:21'!
ask: aQuantity price: aPrice

| instance |

instance := OrdenCompra new.

instance setCantidadUnidades: aQuantity.
instance setPrecio: aPrice.


^ instance.
! !

!Order class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:22'!
ask: aQuantity price: aPrice date: aDate

| instance |

instance := OrdenCompra new.

instance setCantidadUnidades: aQuantity.
instance setPrecio: aPrice.
instance setFechaIngreso: aDate.


^ instance.
! !

!Order class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:21'!
bid: aQuantity price: aPrice

| instance |

instance := OrdenVenta new.

instance setCantidadUnidades: aQuantity.
instance setPrecio: aPrice.


^ instance.
! !

!Order class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:21'!
bid: aQuantity price: aPrice date: aDate

| instance |

instance := OrdenVenta new.

instance setCantidadUnidades: aQuantity.
instance setPrecio: aPrice.
instance setFechaIngreso: aDate.


^ instance.
! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 19:02'!
calcularPrecioUnitario
	^(precio / cantidadUnidades)! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 16:43'!
getCantidadUnidades
    ^cantidadUnidades ! !

!Order methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:54'!
getFechaIngreso

| resultado |

(fechaIngreso isKindOf: Date) ifFalse: [ resultado := (Date readFromString: fechaIngreso) ] 
	 ifTrue: [resultado := fechaIngreso].

^ resultado.

! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:06'!
getPrecio
    ^precio! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:08'!
setCantidadUnidades: unaCantidadUnidades
	cantidadUnidades  := unaCantidadUnidades ! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:08'!
setFechaIngreso: unaFechaIngreso
	fechaIngreso := unaFechaIngreso ! !

!Order methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/2/2012 17:09'!
setPrecio: unPrecio
	precio := unPrecio ! !

Object subclass: #OrderBook
	instanceVariableNames: 'ordenesCompra ordenesVenta tickets ocCandidatas ovCandidatas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!OrderBook class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:19'!
new

| instancia | 

instancia := super new.

instancia inicializar.

^instancia.
! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 19:10'!
addOrder: aOrder

(aOrder isKindOf: OrdenVenta) ifTrue: [ordenesVenta add:aOrder].
(aOrder isKindOf: OrdenCompra) ifTrue: [ordenesCompra add:aOrder].! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 19:15'!
ejecutarTrading 


"Ejecuta el proceso de trading"
	
	| precioMercadoCalculado ovTransaccionada ovMatcheadas tradingTicket |

	precioMercadoCalculado := self marketPrice.
	ovCandidatas := self  obtenerOrdenesVentaCandidatas: precioMercadoCalculado.
	ocCandidatas := self obtenerOrdenesCompraCandidatas: precioMercadoCalculado.
	
	"Recorre las OC candidatas y las compara una a una contra las OV con igual cantidad"	
	ocCandidatas do: [:ocTransaccionando | 
					
			ovMatcheadas := ovCandidatas select: [:ov | ov getCantidadUnidades = ocTransaccionando getCantidadUnidades].
			
			(ovMatcheadas size > 0)
 			ifTrue: [ 
				
				"Toma la primera OV con igual cantidad"	
				ovTransaccionada := ovMatcheadas first. 
			
				"Crea el Trading Ticket y remueve las ordenes del orderbook"
				tradingTicket := TradingTicket crear: ocTransaccionando ordenVenta: ovTransaccionada precioMercado: precioMercadoCalculado.			

				self quitarOrdenCompra: ocTransaccionando.
				self quitarOrdenVenta: ovTransaccionada.
				self tradingTickets add: tradingTicket.
				
		  		   ].
			 ].
			! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:48'!
getCantidadOrdenesRegistradas

^(ordenesCompra size) + (ordenesVenta size).! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 18:15'!
getOrdenesCompra
^ordenesCompra! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:52'!
getOrdenesVenta

^ordenesVenta.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:13'!
inicializar

ordenesCompra := OrderedCollection new.
ordenesVenta := OrderedCollection new.

tickets := OrderedCollection new. 
ocCandidatas := SortedCollection new.
ovCandidatas := SortedCollection new.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 19:15'!
marketPrice

| tabla |

"Calcula del precio del mercado en funcin de las ordenes registradas hasta el momento. 
Para calcular el precio del mercado la clase PEM hace uso de la clase TablaPrecioMercado a quien sabe como calcular este precio".

tabla := TablaPrecioMercado crear.

"1 - Agrega todas las ordenes de compra a la tabla" 

(self getOrdenesCompra) do: [:oc |
	
		tabla agregarDemandaPrecio: oc calcularPrecioUnitario cantidad: oc getCantidadUnidades ].

"2 - Agrega todas las ordenes de venta a la tabla"

(self getOrdenesVenta) do: [:ov |
	
		tabla agregarOfertaPrecio: ov calcularPrecioUnitario cantidad: ov getCantidadUnidades].
" 3 - Obtiene el precio del mercado"
^ tabla calcularPrecioMercado.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/8/2012 17:20'!
obtenerOrdenesCompraCandidatas: unPrecioMercado

| ordenesCompraCantidatasFiltradas ordenesCompraCandidatasOrdenadas | 

"Filtrar las ordenes de compra candidatas, es decir las ordenes de compra con precio > al precio de mercado"
ordenesCompraCantidatasFiltradas := ordenesCompra select: [:unaOrdenCompra | (unaOrdenCompra calcularPrecioUnitario) >= unPrecioMercado].

ordenesCompraCandidatasOrdenadas := ordenesCompraCantidatasFiltradas asSortedCollection: 
     [:unaOrdenCompra :otraOrdenCompra | 
	(unaOrdenCompra calcularPrecioUnitario) > (otraOrdenCompra calcularPrecioUnitario)
	or:
	[ (unaOrdenCompra calcularPrecioUnitario) = (otraOrdenCompra calcularPrecioUnitario) and: [(unaOrdenCompra getFechaIngreso) < (otraOrdenCompra getFechaIngreso)] ]
].	
	

^ ordenesCompraCandidatasOrdenadas  ! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/8/2012 17:24'!
obtenerOrdenesVentaCandidatas: unPrecioMercado

| ordenesVentaCantidatasFiltradas ordenesVentaCandidatasOrdenadas | 

"Filtrar las ordenes de centa candidatas, es decir las ordenes de venta con precio < al precio de mercado"
ordenesVentaCantidatasFiltradas := ordenesVenta  select: [:unaOrdenVenta | (unaOrdenVenta calcularPrecioUnitario) <= unPrecioMercado].

ordenesVentaCandidatasOrdenadas := ordenesVentaCantidatasFiltradas asSortedCollection: 
     [:unaOrdenVenta :otraOrdenVenta | 
	(unaOrdenVenta calcularPrecioUnitario) < (otraOrdenVenta calcularPrecioUnitario)
	or:
	[ (unaOrdenVenta calcularPrecioUnitario) = (otraOrdenVenta calcularPrecioUnitario) and: [(unaOrdenVenta getFechaIngreso) < (otraOrdenVenta getFechaIngreso)] ]
].	
	
^ ordenesVentaCandidatasOrdenadas 
! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:24'!
quitarOrdenCompra: unaOrden

ordenesCompra remove: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:24'!
quitarOrdenVenta: unaOrden

ordenesVenta remove: unaOrden.! !

!OrderBook methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:18'!
tradingTickets

^ tickets.! !

Object subclass: #PEM
	instanceVariableNames: 'emisores orderBook'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!PEM class methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 12:50'!
crear
	"Crea una nueva instancia del PEM con las colecciones incializadas"

	| instancia |

instancia := PEM new.
instancia inicializar.
^instancia.
! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:15'!
addOrder: aOrder

orderBook addOrder: aOrder.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:06'!
agregarEmisor: unEmisor

"Agrega un nuevo emisor al PEM"

	emisores add: unEmisor.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:07'!
agregarTradingTicket: unTicket

"Agrega un nuevo Ticket al PEM"

tickets add: unTicket.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:16'!
ejecutarTrading

orderBook ejecutarTrading.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:39'!
getCantidadEmisores

^emisores size.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/8/2012 17:49'!
getCantidadOrdenesRegistradas 

^orderBook getCantidadOrdenesRegistradas.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 20:44'!
getEmisores

^emisores.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/3/2012 18:09'!
getOrderbook
^orderBook ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:19'!
inicializar

"Inicializa las colecciones del PEM"

emisores := OrderedCollection new.

orderBook := OrderBook new.
! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:17'!
marketPrice 

^ orderBook marketPrice.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:07'!
quitarEmisor: unEmisor

emisores remove: unEmisor.! !

!PEM methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/22/2012 19:29'!
setFechaIngresoOC: unaFechaIngreso

self getOrderbook getOrdenesCompra last setFechaIngreso: unaFechaIngreso. ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/22/2012 19:29'!
setFechaIngresoOV: unaFechaIngreso

self getOrderbook getOrdenesVenta last setFechaIngreso: unaFechaIngreso. ! !

!PEM methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/18/2012 18:18'!
tradingTickets 

^ orderBook tradingTickets.! !

Object subclass: #RegistroTablaPrecioMercado
	instanceVariableNames: 'precio demanda oferta demandaTeorica ofertaTeorica'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!RegistroTablaPrecioMercado class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:51'!
crear: unPrecio

| instancia |

instancia := RegistroTablaPrecioMercado new.
instancia inicializar.
instancia setPrecio: unPrecio.

^instancia.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:28'!
calcularUnidadesTeoricas

| resultado |

resultado := 0.

(demandaTeorica <= ofertaTeorica ) ifFalse: [resultado:= ofertaTeorica]  ifTrue: [resultado := demandaTeorica].

^resultado.
! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getDemanda

^demanda.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:02'!
getDemandaTeorica

^demandaTeorica.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getOferta

^oferta.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:03'!
getOfertaTeorica

^ofertaTeorica.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
getPrecio

^precio.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:28'!
inicializar

precio := 0.
demanda := 0.
oferta := 0.
demandaTeorica :=0.
ofertaTeorica :=0.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 23:07'!
setPrecio: unPrecio

precio := unPrecio.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:06'!
sumarDemanda: unaCantidad

demanda := demanda + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:09'!
sumarDemandaTeorica: unaCantidad


demandaTeorica := demandaTeorica + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:57'!
sumarOferta: unaCantidad

oferta := oferta + unaCantidad.! !

!RegistroTablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:09'!
sumarOfertaTeorica: unaCantidad

ofertaTeorica := ofertaTeorica + unaCantidad.! !

Object subclass: #TablaPrecioMercado
	instanceVariableNames: 'filas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!TablaPrecioMercado class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:52'!
crear

| instancia |

instancia := TablaPrecioMercado new.
instancia inicializar.

^instancia.

! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:52'!
agregarDemandaPrecio: unPrecio cantidad: unaCantidad

| fila |

fila := RegistroTablaPrecioMercado crear:unPrecio.
fila sumarDemanda:  unaCantidad.

(filas includesKey:unPrecio) 
	ifFalse: [filas at:unPrecio put: fila]
	ifTrue: [(filas at:unPrecio) sumarDemanda: unaCantidad].
! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 18:56'!
agregarOfertaPrecio: unPrecio cantidad: unaCantidad

| fila |

fila := RegistroTablaPrecioMercado crear:unPrecio.
fila sumarOferta: unaCantidad.


(filas includesKey:unPrecio) 
	ifFalse: [filas at:unPrecio put: fila]
	ifTrue: [(filas at:unPrecio) sumarOferta: unaCantidad].
! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:29'!
calcularDemandaTeoricaPorPrecio


filas do: [:fila |
	
	filas do: [:otraFila |
		
		((fila getPrecio) <= (otraFila getPrecio)) ifTrue: [fila sumarDemandaTeorica: (otraFila getDemanda)].
		
		]	
	
	] ! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 19:31'!
calcularOfertaTeoricaPorPrecio


filas do: [:fila |
	
	filas do: [:otraFila |
		
		((fila getPrecio) >= (otraFila getPrecio)) ifTrue: [fila sumarOfertaTeorica: (otraFila getOferta)].
		
		]	
	
	] ! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 21:30'!
calcularPrecioMercado

| precioMercado unidadesTeoricas |

precioMercado := 0.
unidadesTeoricas :=0.


self calcularOfertaTeoricaPorPrecio.
self calcularDemandaTeoricaPorPrecio.

filas do: [:fila |
	
	(unidadesTeoricas < fila calcularUnidadesTeoricas)	 ifTrue: [
													unidadesTeoricas:= fila calcularUnidadesTeoricas.
													precioMercado := fila getPrecio.]
	
	].


^precioMercado.! !

!TablaPrecioMercado methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/3/2012 17:57'!
inicializar

filas := Dictionary new.

! !

Object subclass: #TradingTicket
	instanceVariableNames: 'ordenCompra ordenVenta fechaTransaccion precioMercado'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TyH-TP-Final-Modelo'!

!TradingTicket class methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/1/2012 22:15'!
crear: unaOrdenCompra ordenVenta: unaOrdenVenta precioMercado: unPrecio

| instancia | 


instancia := TradingTicket new.

instancia setPrecioMercado: unPrecio.
instancia setOrdenCompra: unaOrdenCompra.
instancia setOrdenVenta: unaOrdenVenta.
instancia setFechaTransaccion: Date today.

^instancia.
! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:11'!
getFechaTransaccion

	^fechaTransaccion.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getOrdenCompra

	^ordenCompra.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getOrdenVenta

	^ordenVenta.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:10'!
getPrecioMercado

	^precioMercado.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setFechaTransaccion: unaFecha

fechaTransaccion := unaFecha.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:12'!
setOrdenCompra: unaOrdenCompra

ordenCompra := unaOrdenCompra.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'GustavoRodriguez 7/21/2012 23:02'!
setOrdenVenta: unaOrdenVenta

ordenVenta := unaOrdenVenta.! !

!TradingTicket methodsFor: 'setters-getters' stamp: 'CristianGonzalez 7/1/2012 22:13'!
setPrecioMercado: unPrecio

precioMercado := unPrecio.! !

TestCase subclass: #OrderBookTestD1
	instanceVariableNames: ''
	classVariableNames: 'orderBook1 pem'
	poolDictionaries: ''
	category: 'TyH-TP-Final-Test'!

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/22/2012 19:42'!
setUp
	pem := PEM new.
	pem inicializar.
	
"Carga los datos de prueba correspondientes a la solapa Orden 2 del archivo Excel"

"Crea las ordenes de compra"
     pem addOrder: ((Order ask: 1  price: 25) setFechaIngreso: '01/01/2012').	
	pem addOrder: ((Order ask: 2  price: 90) setFechaIngreso: '01/02/2012').
	pem addOrder: ((Order ask: 2  price: 50) setFechaIngreso: '01/07/2012').	
	pem addOrder: ((Order ask: 3  price: 135) setFechaIngreso: '01/08/2012').  
	pem addOrder: ((Order ask: 4  price: 200) setFechaIngreso: '01/09/2012').	
	pem addOrder: ((Order ask: 10  price: 200) setFechaIngreso: '01/03/2012').	
	
"Crea las ordenes de venta"
	pem addOrder: ((Order bid: 2  price: 50) setFechaIngreso: '01/04/2012').	
	pem addOrder: ((Order bid: 1  price: 25) setFechaIngreso: '01/11/2012').
	pem addOrder: ((Order bid: 3  price: 75) setFechaIngreso: '01/12/2012').	
	pem addOrder: ((Order bid: 3  price: 180) setFechaIngreso: '01/10/2012').    
	pem addOrder: ((Order bid: 1  price: 60) setFechaIngreso: '01/05/2012').	
	pem addOrder: ((Order bid: 1  price: 45) setFechaIngreso: '01/06/2012').	
	pem addOrder: ((Order bid: 2  price: 60) setFechaIngreso: '01/13/2012').
	! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/27/2012 20:54'!
setUpEmisores

"Carga los datos de prueba de los Emisores en el archivo Excel".

"Con el fin de respetar el protocolo propuesto en los test presentados en clase, la fecha de ingreso de la orden se establace utilizando un setter y no en el constructor".

pem := PEM new.
pem inicializar.
	
pem agregarEmisor: (Emisor crear: '24356890' nombre: 'Betiana' apellido: 'Rocha' cuit: '30-24356890-8' direccion: 'Alsina 125'). 
pem agregarEmisor: (Emisor crear: '23587458' nombre: 'Cristian ' apellido: 'Cemero' cuit: '30-23587458-6' direccion: 'Santa Fe 4587').
pem agregarEmisor: (Emisor crear: '23698547' nombre: 'Laura ' apellido: 'Pozzi' cuit: '30-23698547-4' direccion: 'Libertador 2359'). 
pem agregarEmisor: (Emisor crear: '19587235' nombre: 'Juan Jos' apellido: 'Lopez' cuit: '30-19587235-3' direccion: 'Avenida 7 568'). 
pem agregarEmisor: (Emisor crear: '18578214' nombre: 'Cintia' apellido: 'Castaa' cuit: '30-18578214-5' direccion: 'Calle 46 1254'). 
pem agregarEmisor: (Emisor crear: '17587402' nombre: 'Daniel' apellido: 'Gonzales' cuit: '30-17587402-3' direccion: 'Montevideo 1586'). 
pem agregarEmisor: (Emisor crear: '29875421' nombre: 'Ral' apellido: 'Saporiti' cuit: '30-29875421-2' direccion: 'Calle 19 258'). 
pem agregarEmisor: (Emisor crear: '30254139' nombre: 'Anselmo' apellido: 'Bartoloti' cuit: '30-30254139-5' direccion: 'Belgrano 1202'). 
pem agregarEmisor: (Emisor crear: '25789143' nombre: 'Mara Jos' apellido: 'Molinos' cuit: '30-25789143-5' direccion: 'Centenario 254'). 
pem agregarEmisor: (Emisor crear: '20198735' nombre: 'Vanesa' apellido: 'Colinos' cuit: '30-20198735-9' direccion: 'Ruta 2 Km 11.'). 
pem agregarEmisor: (Emisor crear: '25698452' nombre: 'Arnaldo' apellido: 'Jimenez' cuit: '30-25698452-8' direccion: 'Costanera 120'). 
pem agregarEmisor: (Emisor crear: '14742569' nombre: 'Alejandra' apellido: 'Rodriguez' cuit: '30-14742569-3' direccion: 'Grecia 125'). 
pem agregarEmisor: (Emisor crear: '13587258' nombre: 'Ernesto' apellido: 'Gilera' cuit: '30-13587258-6' direccion: 'Moldavia 5879'). ! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/27/2012 20:53'!
setUpNoTrading

pem := PEM new.
pem inicializar.

"Carga los datos de prueba: Juego de datos personalizado, en donde existe un precio de mercado pero no hay trading"
   
"Con el fin de respetar el protocolo propuesto en los test presentados en clase, la fecha de ingreso de la orden se establace utilizando un setter y no en el constructor".

"Crea las ordenes de compra"
     pem addOrder: ((Order ask: 1  price: 25) setFechaIngreso: '01/01/2012').	
	pem addOrder: ((Order ask: 5  price: 225) setFechaIngreso: '01/02/2012').
	pem addOrder: ((Order ask: 2  price: 50) setFechaIngreso: '01/07/2012').	
	pem addOrder: ((Order ask: 6  price: 270) setFechaIngreso: '01/08/2012').  
	pem addOrder: ((Order ask: 5  price: 225) setFechaIngreso: '01/09/2012').	
	pem addOrder: ((Order ask: 10  price: 200) setFechaIngreso: '01/03/2012').	
	
"Crea las ordenes de venta"
	pem addOrder: ((Order bid: 2  price: 50) setFechaIngreso: '01/04/2012').	
	pem addOrder: ((Order bid: 1  price: 40) setFechaIngreso: '01/11/2012').
	pem addOrder: ((Order bid: 3  price: 75) setFechaIngreso: '01/12/2012').	
	pem addOrder: ((Order bid: 3  price: 180) setFechaIngreso: '01/10/2012').    
	pem addOrder: ((Order bid: 1  price: 60) setFechaIngreso: '01/05/2012').	
	pem addOrder: ((Order bid: 1  price: 45) setFechaIngreso: '01/06/2012').	
	pem addOrder: ((Order bid: 2  price: 60) setFechaIngreso: '01/13/2012').! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/22/2012 19:43'!
testDepuracionOrdenes
	
	"se inicializan los datos del set de pruebas".
	self setUp.
		
	"Ejecuta el proceso de trading"
	pem ejecutarTrading.
	
	"se valida el objetivo de la prueba".
	self assert: (pem getCantidadOrdenesRegistradas) = 9.! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/21/2012 21:30'!
testEmisores

"se inicializan los datos del set de pruebas".
self setUpEmisores.

"se valida el objetivo de la prueba".
self assert: (pem getCantidadEmisores) = 13.		
		
	! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/22/2012 19:51'!
testMarketPrice

"se inicializan los datos del set de pruebas".
self setUp.	
	
"se valida el objetivo de la prueba".
self assert: (pem marketPrice) = 45.! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/21/2012 21:30'!
testRecepcionOrdenes

"se inicializan los datos del set de pruebas".
self setUp.	
	
"se valida el objetivo de la prueba".
self assert: ((orderBook1 getCantidadOrdenesRegistradas) = 13).! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'CristianGonzalez 7/27/2012 21:40'!
testTradingTickets


| oc2 ov1 oc4 ov3 |

"se inicializan los datos del set de pruebas".
self setUp.

"Se referencian las instancias de las ordenes que tienen que generar tickets para chequear los datos de los tickets posteriormente".

oc2 := (pem getOrderbook getOrdenesCompra select: [:oc | oc getFechaIngreso = (Date readFromString:'01/02/2012')]) first.
oc4 := (pem getOrderbook getOrdenesCompra select: [:oc | oc getFechaIngreso = (Date readFromString:'01/08/2012')]) first.

ov1:= (pem getOrderbook getOrdenesVenta select: [:ov | ov getFechaIngreso = (Date readFromString:'01/04/2012')]) first.
ov3:= (pem getOrderbook getOrdenesVenta select: [:ov | ov getFechaIngreso = (Date readFromString:'01/12/2012')]) first.


"Ejecuta el proceso de trading"
pem ejecutarTrading.

"se valida el objetivo de la prueba".
self assert: (pem tradingTickets size) = 2.

"Se valida que cada ticket tenga asignadas las ordenes correspondientes segn el objetivo de la prueba, para tal fin se comparan las identidades de los objetos."

self assert: ((pem tradingTickets first) getOrdenCompra) == oc2.
self assert: ((pem tradingTickets first) getOrdenVenta) == ov1.

self assert: ((pem tradingTickets last) getOrdenCompra) == oc4.
self assert: ((pem tradingTickets last) getOrdenVenta) == ov3.
! !

!OrderBookTestD1 methodsFor: 'as yet unclassified' stamp: 'GustavoRodriguez 7/22/2012 19:52'!
testTradingTicketsNoMatch

"se inicializan los datos del set de pruebas".
self setUpNoTrading.

"Ejecuta el proceso de trading"
pem ejecutarTrading.
	
"se valida el objetivo de la prueba: Hay precio de mercado pero no hay trading".
self assert: (pem marketPrice) = 45.
self assert: (pem tradingTickets size) = 0.! !
